package totext;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.HashMap;
import java.util.Iterator;

public class TextMessage
{

	private final static String TARGET_URL = "http://www.totext.net/selfcare/com/zipzaptext/selfcare/SendMessagesApi.action";
	private final static String USERNAME = "<your username>";
	private final static String PASSWORD = "<your password>";
	private String message = null;
	private String destination = null;
	
	public TextMessage (String message, String destination) {
		this.message = message;
		this.destination = destination;
	}
	
	/**
	 * @param destination the destination to set
	 */
	public void setDestination(String destination) {
		this.destination = destination;
	}



	/**
	 * @param message the message to set
	 */
	public void setMessage(String message) {
		this.message = message;
	}



	public boolean send () {

		HashMap<String, String> hash = new HashMap<String, String> ();

		hash.put("message", message);
		hash.put("destination", destination);
		hash.put("username", USERNAME);
		hash.put("password", PASSWORD);

		InputStreamReader in = null;
		OutputStreamWriter out = null;

		boolean sent = false;

		try {
			URL server = new URL(TARGET_URL);

			HttpURLConnection connection = (HttpURLConnection)server.openConnection();
			StringBuffer params = new StringBuffer();

			int num=0;

			for (Iterator iter = hash.keySet().iterator(); iter.hasNext();) {
				String name = (String) iter.next();
				if (num++>0) {
					params.append("&");
				}
				params.append(URLEncoder.encode(name, "UTF-8") + "=" + URLEncoder.encode( (String) hash.get(name), "UTF-8"));
			}

			connection.setDoOutput(true);
			connection.setDoInput(true);

			connection.setRequestMethod("POST");
			connection.setUseCaches(false);
			connection.setRequestProperty("Content-Type","application/x-www-form-urlencoded");
			connection.setRequestProperty("User-Agent","totext.net Messaging API");
			connection.setRequestProperty("Content-Length",String.valueOf(params.length()));

			connection.connect();

			out = new OutputStreamWriter(connection.getOutputStream(),"UTF-8");
			out.write(params.toString());
			out.flush();

			in = new InputStreamReader(connection.getInputStream());
			BufferedReader bufferedReader = new BufferedReader (in);

			// get the response, although actually we'll silently discard it for now
			int watchdog = 0;
			String response;
			while (((response = bufferedReader.readLine()) != null) && (watchdog++ < 5000)) {
				System.out.println ("Response line from http post: " + response);
			}

			sent = true;

			out.close();
			in.close();
		}
		catch (Exception except) {
			System.out.println ("Failed to execute http post: " + except.getMessage());
		}
		
		return sent;
	}
}
